/****************************************************************************
 * This file is part of the project AqHome.
 * AqHome (c) by 2023 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif



#include "aqhome/msg/node/m_addr.h"
#include "aqhome/msg/node/m_node.h"

#include <gwenhywfar/debug.h>


#define AQH_MSG_OFFS_ADDR_UID          0   /* 4 bytes */
#define AQH_MSG_OFFS_ADDR_ADDR         4   /* 1 bytes */



uint32_t AQH_AddrMessage_GetUid(const AQH_MESSAGE *msg)
{
  return AQH_Message_ReadUint32At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_ADDR_UID, 0);
}



uint8_t AQH_AddrMessage_GetAddr(const AQH_MESSAGE *msg)
{
  return AQH_Message_ReadUint8At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_ADDR_ADDR, 0);
}



void AQH_AddrMessage_DumpToBuffer(const AQH_MESSAGE *msg, GWEN_BUFFER *dbuf, const char *sText)
{
  GWEN_Buffer_AppendArgs(dbuf,
                         "0x%02x->0x%02x: ADDR(%s) %s (uid=0x%08x, addr=%d)\n",
                         AQH_NodeMessage_GetSourceAddress(msg),
                         AQH_NodeMessage_GetDestAddress(msg),
                         AQH_NodeMessage_MsgTypeToChar(AQH_NodeMessage_GetMsgType(msg)),
                         sText,
                         (unsigned int) AQH_AddrMessage_GetUid(msg),
                         AQH_AddrMessage_GetAddr(msg));
}


